// Written by Jason Heddings: http://mapit.mozdev.org/
// License: http://creativecommons.org/licenses/by-nc-sa/2.0/

// These are the known map sites...
// http://www.mapquest.com/

// Here are some links that I'd like to incorporate into the extension...
// http://www.mappoint.com
// http://www.maps.com/directions/address/simple_address.html
// http://www.randmcnally.com/rmc/directions/dirGetMapInput.jsp
// http://terraserver.microsoft.com/address.aspx
// http://www.globexplorer.com/

////////////////////////////////////////////////////////////////////////////////
// Generates a page in a new tab or window

function mapitGeneratePage(url) {
  var settings = new MapItSettings();
  var genPage = window;

  // check where to send the map
  if (settings.target == "tab") {
    getBrowser().selectedTab = getBrowser().addTab(url);
  } else if (settings.target == "blank") {
    genPage = window.open(url);
  } else {
    // the new page is set to the current window
  }

  return genPage;
}

////////////////////////////////////////////////////////////////////////////////
// Creates a form element.

function mapitGenerateInput(page, name, value) {
  var input = page.content.document.createElement("input");
  input.setAttribute("type", "hidden");
  input.setAttribute("name", name);
  input.setAttribute("value", value);
  return input;
}

////////////////////////////////////////////////////////////////////////////////
// Create the MapQuest form.

function mapitMapQuest(address) {
  // action="http://www.mapquest.com/maps/map.adp" method="get"
  // input="searchtype" value="address"
  // input="country"
  // input="address"
  // input="city"
  // input="state"
  // input="zipcode"

  // This must be done to make generated content render
  const request = new XMLHttpRequest();
  request.open("GET", window.content.document.URL, true);
  request.send("");

  var page = mapitGeneratePage("about:blank");
  var form = page.content.document.createElement("form")
  form.setAttribute("method", "get");
  form.setAttribute("action", "http://www.mapquest.com/maps/map.adp");

  form.appendChild(mapitGenerateInput(page, "searchtype", "address"));
  form.appendChild(mapitGenerateInput(page, "country", address.country));
  form.appendChild(mapitGenerateInput(page, "address", address.street));
  form.appendChild(mapitGenerateInput(page, "city", address.city));
  form.appendChild(mapitGenerateInput(page, "state", mapitAbbreviateState(address.state)));
  form.appendChild(mapitGenerateInput(page, "zipcode", address.zip));

  page.content.document.body.appendChild(form);
  form.submit();
}

////////////////////////////////////////////////////////////////////////////////
// Create the MapQuest form.

function mapitMapsDotCom(address) {
  // action="http://host.maptuit.com/maps.com/index.cgi" method="post"
  // input="AddrPickBest" value="1"
  // input="Address"
  // input="City"
  // input="Postal"
  // input="Region"

  // This must be done to make generated content render
  const request = new XMLHttpRequest();
  request.open("GET", window.content.document.URL, true);
  request.send("");

  var page = mapitGeneratePage("about:blank");
  var form = page.content.document.createElement("form")
  form.setAttribute("method", "post");
  form.setAttribute("action", "http://host.maptuit.com/maps.com/index.cgi");

  form.appendChild(mapitGenerateInput(page, "AddrPickBest", "1"));
  form.appendChild(mapitGenerateInput(page, "Address", address.street));
  form.appendChild(mapitGenerateInput(page, "City", address.city));
  form.appendChild(mapitGenerateInput(page, "Region", mapitAbbreviateState(address.state)));
  form.appendChild(mapitGenerateInput(page, "Postal", address.zip));

  page.content.document.body.appendChild(form);
  form.submit();
}
